diff --git a/contrib/package/freifunk-common/files/usr/sbin/ff_olsr_watchdog b/contrib/package/freifunk-common/files/usr/sbin/ff_olsr_watchdog
index aa8de61..fef0d76 100755
--- a/contrib/package/freifunk-common/files/usr/sbin/ff_olsr_watchdog
+++ b/contrib/package/freifunk-common/files/usr/sbin/ff_olsr_watchdog
@@ -4,6 +4,7 @@ require "os"
 require "io"
 require "uci"
 local fs = require "nixio.fs"
+local restart = 0
 
 if fs.access("/var/run/olsrd.pid") then
 	local stamp, intv
@@ -22,8 +23,35 @@ if fs.access("/var/run/olsrd.pid") then
 		local wdgtime = tonumber(io.lines(stamp)())
 
 		if not wdgtime or ( systime - wdgtime ) > ( intv * 2 ) then
-			os.execute("logger -t 'OLSR watchdog' 'Process died - restarting!'")
-			os.execute("/etc/init.d/olsrd restart")
+			os.execute("logger -t 'OLSR IPv4 watchdog' 'Process died - restarting!'")
+			restart = 1	end
+	end
+end
+
+if fs.access("/var/run/olsrd.ipv6.pid") then
+	local stamp, intv
+	local x = uci.cursor()
+
+	x:foreach("olsrd", "LoadPlugin",
+		function(s)
+			if s.library == "olsrd_watchdog.so.0.1" then
+				intv  = tonumber(s.interval)
+				stamp = s.file..".ipv6"
+			end
+		end)
+
+	if intv and fs.access(stamp) then
+		local systime = os.time()
+		local wdgtime = tonumber(io.lines(stamp)())
+
+		if not wdgtime or ( systime - wdgtime ) > ( intv * 2 ) then
+			os.execute("logger -t 'OLSR IPv6 watchdog' 'Process died - restarting!'")
+			restart = 1
 		end
 	end
 end
+
+if restart == 1 then
+	os.execute("/etc/init.d/olsrd restart")
+end
+
